unit Ugraphs;

interface

  procedure FindHydrMax;
  procedure HydrRelative;
  procedure FindWTMaxMin;
  procedure WTRelative;
  procedure FindSaltMaxMin;
  procedure SaltRelative;

  const
    PosX1=70;
    PosX2=PosX1+500;
    PosY1=50;
    PosY2=PosY1+300;

  var Ymax, Ymin, Xmax, Xmin                                          : real;
      WTMax, WTMin : real;
      MaxY, MinY, MaxX, MinX, ScaleY, ScaleX, DecimY, DecimX,
      LX, LY                                                         : integer;
      XdataRel, PercRel, CapRel, DrcRel, RainRel, IrriRel, EvapRel,
      SdrRel, SaltStoRel                                             : real;
      Salt1Rel, Salt2Rel, Salt3Rel, Salt1MRel, Salt2MRel, Salt3MRel,
      SaltTrRel, SaltDrainRel,SaltTrMRel, SaltAqRel, SaltAqMRel, WTRel : real;
      RelXdata, RelPerc, RelCap, RelDrc, RelRain, RelIrri,
      RelEvap, RelWT, RelSdr, RelSaltSto                    : array of integer;
//To be replaced by RelA, RelB, RelC, RelD, RelE, RelF for multiple use
      RelSalt1, RelSalt2, RelSalt3, RelSalt1M, RelSalt2M,
      RelSalt3M, RelSaltTR, RelSaltTrM, RelSaltAQ, RelSaltAqM,
      RelSaltDrain                                           : array of integer;
      ExclSubSurf, ExclSurf, ExclSalFirst, ExclSalSecond, 
      ExclSalThird, ExclSalBelow, NoExclusion, IncludeAll, SurfSto : boolean;

implementation

uses UMain, Ucalc;

procedure FindHydrMax;
var i : integer;
    HydrMax : real;
begin
  HydrMax:=0;
  if not ExclSurf and not ExclSubSurf then
  for i:=1 to NrOfSteps do
  begin
    if Rain[i]>HydrMax then HydrMax:=Rain[i];
    if Irri[i]>HydrMax then HydrMax:=Irri[i];
    if EPAf[i]>HydrMax then HydrMax:=EPAf[i];
    if PercF[i]>HydrMax then HydrMax:=PercF[i];
    if CapF[i]>HydrMax then HydrMax:=CapF[i];
    if DRCf[i]>HydrMax then HydrMax:=DRCf[i];
//    if SurfDr[i]>HydrMax then HydrMax:=SurfDr[i];
  end;
  if ExclSurf then
  for i:=1 to NrOfSteps do
  begin
    if PercF[i]>HydrMax then HydrMax:=PercF[i];
    if CapF[i]>HydrMax then HydrMax:=CapF[i];
    if DRCf[i]>HydrMax then HydrMax:=DRCf[i];
  end;
  if ExclSubSurf then
  for i:=1 to NrOfSteps do
  begin
    if Rain[i]>HydrMax then HydrMax:=Rain[i];
    if Irri[i]>HydrMax then HydrMax:=Irri[i];
    if EPAf[i]>HydrMax then HydrMax:=EPAf[i];
//    if SurfDr[i]>HydrMax then HydrMax:=SurfDr[i];
  end;

  HydrMax:=HydrMax*1.2;
  if MainForm.GraphHydrRadioButton.checked then HydrMax:=HydrMax*1.2;
  Ymax:=HydrMax;
  Ymin:=0;
  MinY:=0;
  Xmax:=NrOfSteps+1;
  Xmin:=0;
  MinX:=0;
  MaxY   := round (YMax+2);
  ScaleY := MaxY-MinY;
  decimY := 2;
  if (ScaleY>10) and (ScaleY<=20) then
  begin
     ScaleY:=round(Ymax-8) - MinY;
     decimY:=1;
  end;
  if (ScaleY>20) and (ScaleY<=30) then
  begin
     ScaleY:=round(Ymax-18) - MinY;
     decimY:=1;
  end;
  if (ScaleY>30) and (ScaleY<=40) then
  begin
     ScaleY:=round(Ymax-28) - MinY;
     decimY:=1;
  end;
  if (ScaleY>40) and (ScaleY<=50) then
  begin
     ScaleY:=round(Ymax-38) - MinY;
     decimY:=0;
  end;
  if (ScaleY>50) then
  begin
     ScaleY:=round(Ymax-48) - MinY;
     decimY:=0;
  end;
  if ScaleY>10 then ScaleY:=10;
  if ScaleY<4 then ScaleY:=5;

  if Xmax<10 then
  begin
    MaxX := round (Xmax+0.5);
    ScaleX := MaxX-MinX;
  end
  else if Xmax<25 then
  begin
    MaxX := 4*round ((Xmax+2)/4);
    ScaleX := (MaxX-MinX) div 4;
  end
  else if Xmax<50 then
  begin
    MaxX := 5*round ((Xmax+2.5)/5);
    ScaleX := (MaxX-MinX) div 5;
  end
  else if Xmax<100 then
  begin
    MaxX := 10*round ((Xmax+5)/10);
    ScaleX := (MaxX-MinX) div 10;
  end
  else if Xmax<250 then
  begin
    MaxX := 25*round ((2*Xmax+25)/50);
    ScaleX := (MaxX-MinX) div 25;
  end
  else if Xmax<500 then
  begin
    MaxX := 50*round ((Xmax+25)/50);
    ScaleX := (MaxX-MinX) div 50;
  end
  else if Xmax<1000 then
  begin
    MaxX := 100*round ((Xmax+50)/100);
    ScaleX := (MaxX-MinX) div 100;
  end
  else if Xmax<10000 then
  begin
    MaxX := 1000*round ((Xmax+500)/1000);
    ScaleX := (MaxX-MinX) div 1000;
  end
  else
  begin
    MaxX := 10000*round ((Xmax+5000)/10000);
    ScaleX := (MaxX-MinX) div 10000;
  end;
  DecimX := 0;
  if Xmax<6 then DecimX:=1;
end; {procedure FindHydrMax}



procedure FindSaltMaxMin;
var i : integer;
    SaltAllMax, SaltAllMin : real;
begin
  SaltAllMax:=0;
  if NoExclusion then
  for i:=1 to NrOfSteps do
  begin
    if SaltLay1[i]>SaltAllMax then SaltAllMax:=SaltLay1[i];
    if SaltLay2[i]>SaltAllMax then SaltAllMax:=SaltLay2[i];
    if SaltLay3[i]>SaltAllMax then SaltAllMax:=SaltLay3[i];
    if SaltRoot1M[i]>SaltAllMax then SaltAllMax:=SaltRoot1M[i];
    if SaltRoot2M[i]>SaltAllMax then SaltAllMax:=SaltRoot2M[i];
    if SaltRoot3M[i]>SaltAllMax then SaltAllMax:=SaltRoot3M[i];
    if SaltTR[i]>SaltAllMax then SaltAllMax:=SaltTR[i];
    if SaltTransM[i]>SaltAllMax then SaltAllMax:=SaltTRansM[i];
//    if SaltDrain[i]>SaltAllMax then SaltAllMax:=SaltDrain[i];
    if SaltAQ[i]>SaltAllMax then SaltAllMax:=SaltAQ[i];
    if SaltAquifM[i]>SaltAllMax then SaltAllMax:=SaltAquifM[i];
//    if SaltSto[i]>SaltAllMax then SaltAllMax:=SaltSto[i];
  end;
  if (NrOfLayers>1) and ExclSalBelow and IncludeAll then
  for i:=1 to NrOfSteps do
  begin
    if SaltLay1[i]>SaltAllMax then SaltAllMax:=SaltLay1[i];
    if SaltLay2[i]>SaltAllMax then SaltAllMax:=SaltLay2[i];
    if SaltRoot1M[i]>SaltAllMax then SaltAllMax:=SaltRoot1M[i];
    if SaltRoot2M[i]>SaltAllMax then SaltAllMax:=SaltRoot2M[i];
//    if SaltSto[i]>SaltAllMax then SaltAllMax:=SaltSto[i];
    if NrOfLayers=3 then
    begin
      if SaltLay3[i]>SaltAllMax then SaltAllMax:=SaltLay3[i];
      if SaltRoot3M[i]>SaltAllMax then SaltAllMax:=SaltRoot3M[i];
    end;
  end;
  if ExclSalSecond and ExclSalThird and ExclSalBelow then
  for i:=1 to NrOfSteps do
  begin
    if SaltLay1[i]>SaltAllMax then SaltAllMax:=SaltLay1[i];
    if SaltRoot1M[i]>SaltAllMax then SaltAllMax:=SaltRoot1M[i];
//    if SaltSto[i]>SaltAllMax then SaltAllMax:=SaltSto[i];
  end;
  if ExclSalFirst and ExclSalThird and ExclSalBelow then
  for i:=1 to NrOfSteps do
  begin
    if SaltLay2[i]>SaltAllMax then SaltAllMax:=SaltLay2[i];
    if SaltRoot2M[i]>SaltAllMax then SaltAllMax:=SaltRoot2M[i];
  end;
  if ExclSalFirst and ExclSalSecond and ExclSalBelow then
  for i:=1 to NrOfSteps do
  begin
    if SaltLay3[i]>SaltAllMax then SaltAllMax:=SaltLay3[i];
    if SaltRoot3M[i]>SaltAllMax then SaltAllMax:=SaltRoot3M[i];
  end;
  if ExclSalFirst and ExclSalSecond and ExclSalThird then
  for i:=1 to NrOfSteps do
  begin
    if SaltTR[i]>SaltAllMax then SaltAllMax:=SaltTR[i];
    if SaltTransM[i]>SaltAllMax then SaltAllMax:=SaltTRansM[i];
    if SaltAQ[i]>SaltAllMax then SaltAllMax:=SaltAQ[i];
//    if SaltDrain[i]>SaltAllMax then SaltAllMax:=SaltDrain[i];
    if SaltAquifM[i]>SaltAllMax then SaltAllMax:=SaltAquifM[i];
  end;

  SaltAllMin:=1000000;
  if NoExclusion then
  for i:=1 to NrOfSteps do
  begin
    if SaltLay1[i]<SaltAllMin then SaltAllMin:=SaltLay1[i];
    if SaltLay2[i]<SaltAllMin then SaltAllMin:=SaltLay2[i];
    if SaltLay3[i]<SaltAllMin then SaltAllMin:=SaltLay3[i];
    if (SaltRoot1M[i]>0) and (SaltRoot1M[i]<SaltAllMin) then
        SaltAllMin:=SaltRoot1M[i];
    if (SaltRoot2M[i]>0) and (SaltRoot2M[i]<SaltAllMin) then
        SaltAllMin:=SaltRoot2M[i];
    if (SaltRoot3M[i]>0) and (SaltRoot3M[i]<SaltAllMin) then
        SaltAllMin:=SaltRoot3M[i];
    if SaltTR[i]<SaltAllMin then SaltAllMin:=SaltTR[i];
//    if SaltyDrain then if SaltDrain[i]<SaltAllMin then
//       SaltAllMin:=SaltDrain[i];
    if (SaltTransM[i]>0) and (SaltTransM[i]<SaltAllMin) then
        SaltAllMin:=SaltRoot1M[i];
//    if (SaltSto[i]>0) and (SaltSto[i]<SaltAllMin) then
//        SaltAllMin:=SaltSto[i];
  end;
  if (NrOfLayers>1) and ExclSalBelow and IncludeAll 
  then for i:=1 to NrOfSteps do
  begin
    if SaltLay1[i]<SaltAllMin then SaltAllMin:=SaltLay1[i];
    if SaltLay2[i]<SaltAllMin then SaltAllMin:=SaltLay2[i];
    if (SaltRoot1M[i]>0) and (SaltRoot1M[i]<SaltAllMin) then
        SaltAllMin:=SaltRoot1M[i];
    if (SaltRoot2M[i]>0) and (SaltRoot2M[i]<SaltAllMin) then
        SaltAllMin:=SaltRoot2M[i];
//    if (SaltSto[i]>0) and (SaltSto[i]<SaltAllMin) then
//        SaltAllMin:=SaltSto[i];
    if NrOfLayers=3 then
    begin
      if SaltLay3[i]<SaltAllMin then SaltAllMin:=SaltLay3[i];
      if (SaltRoot3M[i]>0) and (SaltRoot3M[i]<SaltAllMin) then
        SaltAllMin:=SaltRoot3M[i];
    end;
  end;
  if ExclSalFirst and ExclSalThird and ExclSalBelow then
  for i:=1 to NrOfSteps do
  begin
    if SaltLay2[i]<SaltAllMin then SaltAllMin:=SaltLay2[i];
    if (SaltRoot2M[i]>0) and (SaltRoot2M[i]<SaltAllMin) then
        SaltAllMin:=SaltRoot2M[i];
  end;
  if ExclSalSecond and ExclSalThird and ExclSalBelow then
  for i:=1 to NrOfSteps do
  begin
    if SaltLay1[i]<SaltAllMin then SaltAllMin:=SaltLay1[i];
    if (SaltRoot1M[i]>0) and (SaltRoot1M[i]<SaltAllMin) then
        SaltAllMin:=SaltRoot1M[i];
  end;
  if ExclSalFirst and ExclSalSecond and ExclSalBelow then
  for i:=1 to NrOfSteps do
  begin
    if SaltLay3[i]<SaltAllMin then SaltAllMin:=SaltLay3[i];
    if (SaltRoot3M[i]>0) and (SaltRoot3M[i]<SaltAllMin) then
        SaltAllMin:=SaltRoot3M[i];
  end;
  if ExclSalFirst and ExclSalSecond and ExclSalThird then
  for i:=1 to NrOfSteps do
  begin
    if SaltTR[i]<SaltAllMin then SaltAllMin:=SaltTR[i];
//    if SaltyDrain then if SaltDrain[i]<SaltAllMin then
//       SaltAllMin:=SaltDrain[i];
    if (SaltTransM[i]>0) and (SaltTransM[i]<SaltAllMin) then
        SaltAllMin:=SaltTransM[i];
    if SaltAQ[i]<SaltAllMin then SaltAllMin:=SaltAQ[i];
    if (SaltAquifM[i]>0) and (SaltAquifM[i]<SaltAllMin) then
        SaltAllMin:=SaltAquifM[i];
  end;

  Ymax:=1.4*SaltAllMax;
  Ymin:=0.8*SaltAllMin;
  if Ymin<0 then Ymin:=0;
  MaxY:=round(Ymax);
  MinY:=round(Ymin-0.5);
  Xmax:=NrOfSteps+1;
  Xmin:=0;
  MinX:=0;
  DecimY := 1;
  DecimX := 0;
  if Xmax<6 then DecimX:=1;
  ScaleY := MaxY-MinY;
  if Ymax<10 then
  begin
    MaxY := round (Ymax+0.5);
    ScaleY := MaxY-MinY;
  end
  else if Ymax<25 then
  begin
    MaxY := 4*round ((Ymax+2)/4);
    ScaleY := (MaxY-MinY) div 4;
  end;
  if ScaleY<5 then ScaleY:=2*ScaleY;
  if ScaleY<5 then ScaleY:=2*ScaleY;
  if ScaleY>10 then ScaleY:=10;

  if Xmax<10 then
  begin
    MaxX := round (Xmax+0.5);
    ScaleX := MaxX-MinX;
  end
  else if Xmax<25 then
  begin
    MaxX := 4*round ((Xmax+2)/4);
    ScaleX := (MaxX-MinX) div 4;
  end
  else if Xmax<50 then
  begin
    MaxX := 5*round ((Xmax+2.5)/5);
    ScaleX := (MaxX-MinX) div 5;
  end
  else if Xmax<100 then
  begin
    MaxX := 10*round ((Xmax+5)/10);
    ScaleX := (MaxX-MinX) div 10;
  end
  else if Xmax<250 then
  begin
    MaxX := 25*round ((2*Xmax+25)/50);
    ScaleX := (MaxX-MinX) div 25;
  end
  else if Xmax<500 then
  begin
    MaxX := 50*round ((Xmax+25)/50);
    ScaleX := (MaxX-MinX) div 50;
  end
  else if Xmax<1000 then
  begin
    MaxX := 100*round ((Xmax+50)/100);
    ScaleX := (MaxX-MinX) div 100;
  end
  else if Xmax<10000 then
  begin
    MaxX := 1000*round ((Xmax+500)/1000);
    ScaleX := (MaxX-MinX) div 1000;
  end
  else
  begin
    MaxX := 10000*round ((Xmax+5000)/10000);
    ScaleX := (MaxX-MinX) div 10000;
  end;
  if ScaleX<5 then ScaleX:=2*ScaleX;
  if ScaleX>10 then ScaleX:=10;
end; {procedure FindSaltAllMax}


procedure FindWTMaxMin;
var i : integer;
begin

  for i:=1 to NrOfSteps do DepthWT[i]:=-DepthWT[i];

  WTMax:=-1000000;
  WTMin:=1000000;
  for i:=1 to NrOfSteps do
  begin
    if DepthWT[i]>WTMax then WTMax:=DepthWT[i];
    if DepthWT[i]<WTMin then WTMin:=DepthWT[i];
  end;
  Ymax:=1.2*WTMax;
  if Ymax<0 then Ymax:=0;
  MaxY:=round(Ymax+0.5);
  Ymin:=0.9*WTMin;
  MinY:=round(Ymin-0.5);
  Xmax:=NrOfSteps+1;
  Xmin:=0;
  MinX:=0;
  DecimY := 1;
  DecimX := 0;
  if Xmax<6 then DecimX:=1;
  ScaleY := MaxY-MinY;
  if ScaleY>10 then ScaleY:=10;

  if Ymax<10 then
  begin
    MaxY := round (Ymax+0.5);
    ScaleY := MaxY-MinY;
  end
  else if Ymax<25 then
  begin
    MaxY := 4*round ((Ymax+2)/4);
    ScaleY := (MaxY-MinY) div 4;
  end;
  if ScaleY<5 then ScaleY:=2*ScaleY;
  if ScaleY<5 then ScaleY:=2*ScaleY;

  if Xmax<10 then
  begin
    MaxX := round (Xmax+0.5);
    ScaleX := MaxX-MinX;
  end
  else if Xmax<25 then
  begin
    MaxX := 4*round ((Xmax+2)/4);
    ScaleX := (MaxX-MinX) div 4;
  end
  else if Xmax<50 then
  begin
    MaxX := 5*round ((Xmax+2.5)/5);
    ScaleX := (MaxX-MinX) div 5;
  end
  else if Xmax<100 then
  begin
    MaxX := 10*round ((Xmax+5)/10);
    ScaleX := (MaxX-MinX) div 10;
  end
  else if Xmax<250 then
  begin
    MaxX := 25*round ((2*Xmax+25)/50);
    ScaleX := (MaxX-MinX) div 25;
  end
  else if Xmax<500 then
  begin
    MaxX := 50*round ((Xmax+25)/50);
    ScaleX := (MaxX-MinX) div 50;
  end
  else if Xmax<1000 then
  begin
    MaxX := 100*round ((Xmax+50)/100);
    ScaleX := (MaxX-MinX) div 100;
  end
  else if Xmax<10000 then
  begin
    MaxX := 1000*round ((Xmax+500)/1000);
    ScaleX := (MaxX-MinX) div 1000;
  end
  else
  begin
    MaxX := 10000*round ((Xmax+5000)/10000);
    ScaleX := (MaxX-MinX) div 10000;
  end;
  if ScaleX<5 then ScaleX:=2*ScaleX;
end; {procedure FindWTMaxMin}



procedure HydrRelative;
var i : integer;
begin
  LX := posX2-posX1;
  LY := posY2-posY1;
  for i:=1 to NrOfSteps do
  begin
    XdataRel := LX*i/(MaxX-MinX);
    SetLength (RelXdata,i+1);
    RelXdata[i] := PosX1+round(XdataRel);
    if not ExclSubSurf then
    begin
      PercRel := LY*(PercF[i]-MinY)/(MaxY-MinY);
      SetLength (RelPerc,i+1);
      RelPerc[i] := PosY2-round(PercRel)-2;
      CapRel := LY*(CapF[i]-MinY)/(MaxY-MinY);
      SetLength (RelCap,i+1);
      RelCap[i] := PosY2-round(CapRel)-2;
      DrcRel := LY*(DrcF[i]-MinY)/(MaxY-MinY);
      SetLength (RelDrc,i+1);
      RelDrc[i] := PosY2-round(DrcRel)-2;
    end;
    if not ExclSurf then
    begin
      RainRel := LY*(Rain[i]-MinY)/(MaxY-MinY);
      SetLength (RelRain,i+1);
      RelRain[i] := PosY2-round(RainRel)-2;
      IrriRel := LY*(Irri[i]-MinY)/(MaxY-MinY);
      SetLength (RelIrri,i+1);
      RelIrri[i] := PosY2-round(IrriRel)-2;
//      EvapRel := LY*(Evap[i]-MinY)/(MaxY-MinY);
      EvapRel := LY*(EPAf[i]-MinY)/(MaxY-MinY);
      SetLength (RelEvap,i+1);
      RelEvap[i] := PosY2-round(EvapRel)-2;
//      SdrRel := LY*(SurfDr[i]-MinY)/(MaxY-MinY);
//      SetLength (RelSdr,i+1);
//      RelSdr[i] := PosY2-round(SdrRel)-4;
    end;
  end;
end; {procedure HydrRelative}



procedure WTRelative;
var i : integer;
begin
  LX := posX2-posX1;
  LY := posY2-posY1;
  for i:=1 to NrOfSteps do
  begin
    XdataRel := LX*i/(MaxX-MinX);
    SetLength (RelXdata,i+1);
    RelXdata[i] := PosX1+round(XdataRel);
    WTRel := LY*(DepthWT[i]-MinY)/(MaxY-MinY);
    SetLength (RelWT,i+1);
    RelWT[i] := PosY2-round(WTRel)-4;
  end;
  for i:=1 to NrOfSteps do  DepthWT[i]:=-DepthWT[i];   {restoring values}
end; {procedure WTRelative}



procedure SaltRelative;
var i {, ii} : integer;
begin
  LX := posX2-posX1;
  LY := posY2-posY1;
  for i:=1 to NrOfSteps do
  begin
    XdataRel := LX*i/(MaxX-MinX);
    SetLength (RelXdata,i+1);
    RelXdata[i] := PosX1+round(XdataRel);
    if not ExclSalFirst then
    begin
      Salt1Rel := LY*(SaltLay1[i]-MinY)/(MaxY-MinY);
      SetLength (RelSalt1,i+1);
      RelSalt1[i] := PosY2-round(Salt1Rel);
      Salt1MRel := LY*(SaltRoot1M[i]-MinY)/(MaxY-MinY);
      SetLength (RelSalt1M,i+1);
      RelSalt1M[i] := PosY2-round(Salt1MRel)-2;
//      SaltStoRel := LY*(SaltSto[i]-MinY)/(MaxY-MinY);
//      SetLength (RelSaltSto,i+1);
//      RelSaltSto[i] := PosY2-round(SaltStoRel)-2;
    end;
    if not ExclSalSecond  then
    begin
      Salt2Rel := LY*(SaltLay2[i]-MinY)/(MaxY-MinY);
      SetLength (RelSalt2,i+1);
      RelSalt2[i] := PosY2-round(Salt2Rel);
      Salt2MRel := LY*(SaltRoot2M[i]-MinY)/(MaxY-MinY);
      SetLength (RelSalt2M,i+1);
      RelSalt2M[i] := PosY2-round(Salt2MRel)-2;
    end;
    if not ExclSalThird  then
    begin
      Salt3Rel := LY*(SaltLay3[i]-MinY)/(MaxY-MinY);
      SetLength (RelSalt3,i+1);
      RelSalt3[i] := PosY2-round(Salt3Rel);
      Salt3MRel := LY*(SaltRoot3M[i]-MinY)/(MaxY-MinY);
      SetLength (RelSalt3M,i+1);
      RelSalt3M[i] := PosY2-round(Salt3MRel)-2;
    end;
    if not ExclSalBelow  then
    begin
      SaltTrRel := LY*(SaltTR[i]-MinY)/(MaxY-MinY);
      SetLength(RelSaltTR,i+1);
      RelSaltTR[i] := PosY2-round(SaltTrRel);
      SaltTrMRel := LY*(SaltTransM[i]-MinY)/(MaxY-MinY);
      SetLength(RelSaltTrM,i+1);
      RelSaltTrM[i] := PosY2-round(SaltTrMRel)-2;
//      SaltDrainRel := LY*(SaltDrain[i]-MinY)/(MaxY-MinY);
//      SetLength(RelSaltDrain,i+1);
//      RelSaltDrain[i] := PosY2-round(SaltDrainRel)-12;
      SaltAqRel := LY*(SaltAQ[i]-MinY)/(MaxY-MinY);
      SetLength(RelSaltAQ,i+1);
      RelSaltAQ[i] := PosY2-round(SaltAqRel);
      SaltAqMRel := LY*(SaltAquifM[i]-MinY)/(MaxY-MinY);
      SetLength(RelSaltAqM,i+1);
      RelSaltAqM[i] := PosY2-round(SaltAqMRel)-2;
    end;
  end;
//  ii:=0;
  SurfSto:=true;
  if not ExclSalFirst then for i:=1 to NrOfSteps do
//  if SaltSto[i]>0 then ii:=ii+1;
//  if ii=0 then SurfSto:=false;
end; {procedure SaltRelative}


end.
